/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource['epages.lang.clipboard_test']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.clipboard_test'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/
dojo.provide('epages.lang.clipboard_test');
dojo.require('epages.lang.clipboard');

dojo.extend(epages.lang.Clipboard, {

	test: function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var clipboard = new epages.lang.Clipboard();
		//		boolean = clipboard.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(8);

		var clipboard = this;

		var addValue = 'Value1';
		var addIndex = clipboard.add(addValue);
		eTest.ok(1, 'add returned, index is ' + addIndex);

		var getValue = clipboard.get(addIndex);
		eTest.ok(1, 'get returned');
		eTest.ok(getValue == addValue, 'correct value');

		var setValue = 'Value2';
		eTest.ok(clipboard.set(addIndex, setValue), 'set value');

		var getValue = clipboard.get(addIndex);
		eTest.ok(1, 'get returned');
		eTest.ok(getValue == setValue, 'correct value');

		eTest.ok(!clipboard.set(addIndex + 123, setValue), 'set value at unknown index position');

		var getValue = clipboard.get(addIndex + 123);
		eTest.ok(getValue === undefined, 'get returns undefined for unknown index position');

		return eTest.planned == eTest.correct ? true : false;
	}

});

}
